﻿'-----------------------------------------------
'TUSB-1612ADSM-S用ドライバアクセス用API
'Visual Basic 用モジュール
'
'2013_06_28　株式会社タートル工業
'Copyright (C) 2013 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module USBADSMS
    '連続取り込み設定用構造体宣言
    <StructLayout(LayoutKind.Sequential)> Structure adsms_setting
        Public ChLen As Byte 'チャンネル長 1-16
        <VBFixedArray(16), MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)>
        Public ChPattern() As Byte
        <VBFixedArray(16), MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)>
        Public ChPatternRange() As Byte
        Public TriggerType As Byte 'トリガ種類　1:ソフト　2:外部ディジタル立上り 3:外部ディジタル立下り 4:立上エッジ 5:立下エッジ　6:上限レベル　7:下限レベル
        Public TriggerLevel As Short 'エッジやレベルの閾値
        Public TriggerCh As Byte 'エッジやレベルを検出するチャンネル位置(パターンバッファのポインタ)
        Public ClockSel As Byte '0:内部クロック　1:外部クロック
        Public SamplingClock As Integer '内部クロック間隔 10～16,777,215[uS]
        Public PreTriggerLen As Integer 'プレトリガ長 0～10,000,000
        Public TotalLen As Integer '全取込データバッファ 1～10,000,000
    End Structure

    'API関数宣言

    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Device_Open(
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub Tusbadsms_Device_Close(
                                ByVal id As Short)
    End Sub
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Pio_Write(
                                ByVal id As Short, _
                                ByVal dat As Byte) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Pio_Read(
                                ByVal id As Short, _
                                ByRef dat As Byte) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Single_Sample(
                                ByVal id As Short, _
                                ByVal ch As Byte, _
                                ByVal range As Byte, _
                                ByRef dat As Short) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Status_Read(
                                ByVal id As Short, _
                                ByRef status As Byte, _
                                ByRef ovf As Byte, _
                                ByRef leng As Integer) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Memory_Read(
                                ByVal id As Short, _
                                <[In](), Out()> ByVal Data() As Short, _
                                ByRef leng As Integer) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Sampling_Stop(
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Memory_Clear(
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Sampling_Trigger(
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSADSMS.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbadsms_Sample_Start(
                                ByVal id As Short, _
                                ByRef smplset As adsms_setting) _
                            As Short
    End Function
    'エラーメッセージ出力
    Function Tusbadsms_GetErrMessage(ByVal retcode As Short) As String
        Select Case retcode
            Case 0
                Return "正常終了しました"
            Case 1
                Return "ID番号が不正です"
            Case 2
                Return "ドライバがインストールされていません"
            Case 3
                Return "すでにデバイスはオープンされています"
            Case 4
                Return "接続されている台数が多すぎます"
            Case 5
                Return "オープンできませんでした"
            Case 6
                Return "デバイスがみつかりません"
            Case 7
                Return "オープンされていません"
            Case 8
                Return "パラメータエラー"
            Case 9
                Return "USB通信エラーです"
            Case Else
                Return "不明なエラーです"
        End Select
    End Function
End Module

