﻿Public Class Form1
    Private SaveLeng As Integer 'ファイルへの保存制限数(0の時制限なし)
    Private SaveFile As IO.StreamWriter ' 保存ファイルストリーム
    Private smpl_setting As adsms_setting '取り込み設定
    Private TotalLeng As Integer '取り込み済みデータ長
    Private StopReq As Boolean 'サンプリング停止要求
    Private SamplingBuffer(,) As Short '取り込みバッファ

    'チャンネル選択チェックボックス配列処理用
    Private ChChkArray() As System.Windows.Forms.CheckBox
    'レンジ選択コンボボックス配列処理用
    Private RangeSelArray() As System.Windows.Forms.ComboBox
    '設定の初期化
    Private Sub SettingInit()
        Dim ch As Integer

        'ID選択コンボボックスを初期化します
        IdSel.SelectedIndex = 0
        'コントロールの配列に画面のコントロールを設定します
        ChChkArray = New System.Windows.Forms.CheckBox() {ChChk1, ChChk2, ChChk3, ChChk4, _
                                                          ChChk5, ChChk6, ChChk7, ChChk8, _
                                                          ChChk9, ChChk10, ChChk11, ChChk12, _
                                                          ChChk13, ChChk14, ChChk15, ChChk16}
        RangeSelArray = New System.Windows.Forms.ComboBox() {RangeSel1, RangeSel2, RangeSel3, RangeSel4, _
                                                             RangeSel5, RangeSel6, RangeSel7, RangeSel8, _
                                                             RangeSel9, RangeSel10, RangeSel11, RangeSel12, _
                                                             RangeSel13, RangeSel14, RangeSel15, RangeSel16}
        For ch = 0 To 15
            RangeSelArray(ch).SelectedIndex = 0
        Next

        'トリガ選択コンボボックスを初期化
        TriggerTypeSel.SelectedIndex = 0

        'トリガチャンネル選択コンボボックスを初期化
        TriggerCh.SelectedIndex = 0

        'その他初期化
        TriggerLevel.Text = "2048" 'トリガレベルを中間値
        ClkSel1.Checked = True '内部クロック有効
        ClockInterval.Text = "1000" '内部クロックを1kHz
        PreTriggerLen.Text = "0" 'プレトリガ長を0
        LimitLen.Text = "1000000" '取り込み制限長1000000
        StatusView.Text = "デバイスがオープンされていません" 'ステータス表示
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        SettingInit()
        'イネーブルディセーブル制御
        EnableDisableControl(0)
    End Sub

    'イネーブルディセーブル制御(画面のコントロール表示切替)
    Private Sub EnableDisableControl(ByVal sel As Integer)
        Dim ch As Integer

        Select Case sel
            Case 0 'オープンしていない
                OpenBtn.Enabled = True
                CloseBtn.Enabled = False
                StartBtn.Enabled = False
                StopBtn.Enabled = False
                IdSel.Enabled = True
                TriggerBtn.Enabled = False

                For ch = 0 To 15
                    ChChkArray(ch).Enabled = False
                    RangeSelArray(ch).Enabled = False
                Next

                TriggerTypeSel.Enabled = False
                TriggerLevel.Enabled = False
                TriggerCh.Enabled = False
                ClkSel1.Enabled = False
                ClkSel2.Enabled = False
                ClockInterval.Enabled = False
                PreTriggerLen.Enabled = False
                LimitLen.Enabled = False
            Case 1 'オープンしている(待機)
                OpenBtn.Enabled = False
                CloseBtn.Enabled = True
                StartBtn.Enabled = True
                StopBtn.Enabled = False
                IdSel.Enabled = False
                TriggerBtn.Enabled = False

                For ch = 0 To 15
                    ChChkArray(ch).Enabled = True
                    RangeSelArray(ch).Enabled = True
                Next

                TriggerTypeSel.Enabled = True
                TriggerLevel.Enabled = True
                TriggerCh.Enabled = True
                ClkSel1.Enabled = True
                ClkSel2.Enabled = True
                ClockInterval.Enabled = True
                PreTriggerLen.Enabled = True
                LimitLen.Enabled = True
            Case 2 'オープンしている(サンプリング中)
                OpenBtn.Enabled = False
                CloseBtn.Enabled = False
                StartBtn.Enabled = False
                StopBtn.Enabled = True
                IdSel.Enabled = False
                If TriggerTypeSel.SelectedIndex = 0 Then
                    TriggerBtn.Enabled = True
                Else
                    TriggerBtn.Enabled = False
                End If

                For ch = 0 To 15
                    ChChkArray(ch).Enabled = False
                    RangeSelArray(ch).Enabled = False
                Next

                TriggerTypeSel.Enabled = False
                TriggerLevel.Enabled = False
                TriggerCh.Enabled = False
                ClkSel1.Enabled = False
                ClkSel2.Enabled = False
                ClockInterval.Enabled = False
                PreTriggerLen.Enabled = False
                LimitLen.Enabled = False
        End Select
    End Sub

    'デバイスオープンボタン
    Private Sub OpenBtn_Click(sender As System.Object, e As System.EventArgs) Handles OpenBtn.Click
        Dim ret As Short

        ret = Tusbadsms_Device_Open(IdSel.SelectedIndex)
        If ret Then 'エラー発生
            MsgBox(Tusbadsms_GetErrMessage(ret))
        Else '成功
            'イネーブルディセーブル制御
            EnableDisableControl(1)
            StatusView.Text = "オープンされました"
        End If
    End Sub

    'デバイスクローズボタン
    Private Sub CloseBtn_Click(sender As System.Object, e As System.EventArgs) Handles CloseBtn.Click
        Tusbadsms_Device_Close(IdSel.SelectedIndex)
        'イネーブルディセーブル制御
        EnableDisableControl(0)
        StatusView.Text = "デバイスがオープンされていません"
    End Sub

    '終了処理
    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If CloseBtn.Enabled Then 'クローズしないで終了した場合は
            If StopBtn.Enabled Then 'サンプリングがストップしていない場合は
                StopReq = True 'サンプリング終了
                'Timer1_Timer()
            End If
            Tusbadsms_Device_Close(IdSel.SelectedIndex)
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim ret As Short
        Dim status As Byte
        Dim ovf As Byte
        Dim leng As Long
        Dim buflen As Integer
        Dim tmpData() As Short

        Dim DSize As Integer

        Timer1.Enabled = False

        If StopReq Then '停止要求の確認
            SampleStop()
            StatusView.Text = "サンプリング終了" + vbCrLf + "データ数 = " + CStr(TotalLeng)
            Exit Sub
        End If

        'バッファステータスの確認
        ret = Tusbadsms_Status_Read(IdSel.SelectedIndex, status, ovf, leng)

        If ret <> 0 Then
            MsgBox(Tusbadsms_GetErrMessage(ret))
            SampleStop()
            Exit Sub
        End If

        Select Case status
            Case 0 '停止中
                StatusView.Text = "停止中です"
                Timer1.Enabled = True
            Case 1 'トリガ待ち
                StatusView.Text = "トリガ待ちです"
                Timer1.Enabled = True
            Case 2 'サンプリング中
                If ovf Then 'オーバーフローの時
                    MsgBox("バッファオーバーフローです")
                    SampleStop()
                    Exit Sub
                End If

                If (SaveLeng <> 0) And ((TotalLeng + leng) >= SaveLeng) Then '最大取り込み長を超えていたら
                    leng = SaveLeng - TotalLeng
                    buflen = leng

                    ReDim tmpData(buflen * smpl_setting.ChLen) 'データ処理用バッファの確保

                    DSize = tmpData.Length * 2

                    ret = Tusbadsms_Memory_Read(IdSel.SelectedIndex, tmpData, leng) 'データの読み込み

                    CopyData(tmpData, leng)
                    TotalLeng = TotalLeng + leng
                    SampleStop()
                    StatusView.Text = "サンプリング終了" + vbCrLf + "データ数 = " + CStr(TotalLeng)
                Else
                    buflen = leng
                    ReDim tmpData(buflen * smpl_setting.ChLen) 'データ処理用バッファの確保

                    DSize = tmpData.Length * 2

                    ret = Tusbadsms_Memory_Read(IdSel.SelectedIndex, tmpData, leng) 'データの読み込み

                    CopyData(tmpData, leng)
                    TotalLeng = TotalLeng + leng
                    StatusView.Text = "サンプリング中です" + vbCrLf + "データ数 = " + CStr(TotalLeng)
                    Timer1.Enabled = True
                End If
        End Select
    End Sub

    'データのコピー処理
    Private Sub CopyData(ByVal Data() As Short, ByVal leng As Long)
        Dim pointer As Long
        Dim ch As Long
        Dim cnt As Long

        pointer = 0
        For ch = 0 To smpl_setting.ChLen - 1
            For cnt = TotalLeng To TotalLeng + leng - 1
                SamplingBuffer(ch, cnt) = Data(pointer)
                pointer = pointer + 1
            Next cnt
        Next ch
    End Sub

    'データの書き込み処理
    Private Sub WriteData()
        Dim cnt As Long
        Dim ch As Long
        For cnt = 0 To TotalLeng - 1
            For ch = 0 To smpl_setting.ChLen - 1
                If ch = smpl_setting.ChLen - 1 Then
                    SaveFile.WriteLine(SamplingBuffer(ch, cnt).ToString("0"))
                Else
                    SaveFile.Write(SamplingBuffer(ch, cnt).ToString("0") + ",")
                End If
            Next ch
        Next cnt
    End Sub

    '連続取り込み停止時の処理
    Private Sub SampleStop()
        Timer1.Enabled = False
        Tusbadsms_Sampling_Stop(IdSel.SelectedIndex) 'サンプリング停止
        StatusView.Text = "データ保存中"
        Refresh()
        WriteData()
        SaveFile.Close() 'ファイルを閉じる
        EnableDisableControl(1)
    End Sub

    Private Sub StartBtn_Click(sender As System.Object, e As System.EventArgs) Handles StartBtn.Click
        Dim ret As Short
        Dim ch As Integer

        'チャンネル
        smpl_setting.ChLen = 0
        If smpl_setting.ChPattern Is Nothing Then
            ReDim smpl_setting.ChPattern(15)
        End If
        If smpl_setting.ChPatternRange Is Nothing Then
            ReDim smpl_setting.ChPatternRange(15)
        End If
        For ch = 0 To 15
            If ChChkArray(ch).Checked Then
                smpl_setting.ChPattern(smpl_setting.ChLen) = ch
                smpl_setting.ChPatternRange(smpl_setting.ChLen) = RangeSelArray(ch).SelectedIndex
                smpl_setting.ChLen = smpl_setting.ChLen + 1
            End If
        Next ch
        If smpl_setting.ChLen = 0 Then
            MsgBox("チャンネルが選択されていません")
            Exit Sub
        End If

        'トリガ設定
        smpl_setting.TriggerType = TriggerTypeSel.SelectedIndex + 1
        If smpl_setting.TriggerType >= 3 Then
            If IsNumeric(TriggerLevel.Text) Then
                If TriggerLevel.Text < 1 Or TriggerLevel.Text > 4094 Then
                    MsgBox("トリガレベルが不正です")
                    Exit Sub
                Else
                    smpl_setting.TriggerLevel = CInt(TriggerLevel.Text)
                End If
            Else
                MsgBox("トリガレベル入力値が不正です")
                Exit Sub
            End If
        End If

        'トリガチャンネル

        smpl_setting.TriggerCh = TriggerCh.SelectedIndex

        'クロック設定
        If ClkSel1.Checked Then
            smpl_setting.ClockSel = 0
            If IsNumeric(ClockInterval.Text) Then
                If ClockInterval.Text > 16777215 Or ClockInterval.Text < 10 Then
                    MsgBox("クロック間隔設定値が不正です")
                    Exit Sub
                Else
                    smpl_setting.SamplingClock = CLng(ClockInterval.Text)
                End If
            Else
                MsgBox("クロック間隔入力値が不正です")
                Exit Sub
            End If
        Else
            smpl_setting.ClockSel = 1
        End If

        'プレトリガ長
        If IsNumeric(PreTriggerLen.Text) Then
            If PreTriggerLen.Text > 10000000 Or PreTriggerLen.Text < 0 Then
                MsgBox("プレトリガ設定値が不正です")
                Exit Sub
            Else
                smpl_setting.PreTriggerLen = CLng(PreTriggerLen.Text)
            End If
        Else
            MsgBox("プレトリガ入力値が不正です")
            Exit Sub
        End If

        'PC内　データ取込バッファ
        smpl_setting.TotalLen = 1000000

        'ファイルへの最大保存数
        If IsNumeric(LimitLen.Text) Then
            If LimitLen.Text < 0 Or LimitLen.Text > 100000000 Then
                MsgBox("保存数の設定値が不正です")
                Exit Sub
            Else
                SaveLeng = CLng(LimitLen.Text)
                ReDim SamplingBuffer(smpl_setting.ChLen, SaveLeng)
            End If
        Else
            MsgBox("保存数の入力値が不正です")
            Exit Sub
        End If

        '保存先ファイル名の取得

        SaveFileDialog1.OverwritePrompt = True
        SaveFileDialog1.Filter = "データファイル(*.dat)|*.dat"
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            If IO.File.Exists(SaveFileDialog1.FileName) Then '既存ファイルチェック
                IO.File.Delete(SaveFileDialog1.FileName)
            End If

            SaveFile = New IO.StreamWriter(IO.File.OpenWrite(SaveFileDialog1.FileName)) 'ファイルを開く
            ret = Tusbadsms_Sample_Start(IdSel.SelectedIndex, smpl_setting)
            If ret = 0 Then '正常にスタートできた
                StopReq = False
                TotalLeng = 0
                EnableDisableControl(2)
                Timer1.Interval = 100
                Timer1.Enabled = True
            Else '正常にスタートできなかった
                SaveFile.Close()
                Tusbadsms_Device_Close(IdSel.SelectedIndex)
            End If
        End If
    End Sub

    Private Sub TriggerBtn_Click(sender As System.Object, e As System.EventArgs) Handles TriggerBtn.Click
        Dim ret As Short
        ret = Tusbadsms_Sampling_Trigger(IdSel.SelectedIndex) 'トリガコマンド
        If ret <> 0 Then
            Tusbadsms_Device_Close(IdSel.SelectedIndex)
            StopReq = True
        End If
    End Sub

    Private Sub StopBtn_Click(sender As System.Object, e As System.EventArgs) Handles StopBtn.Click
        StopReq = True
    End Sub
End Class
