﻿Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim id As Integer
        Dim ch As Integer
        'ID選択コンボボックスを初期化します
        For id = 0 To 15
            IdSel.Items.Add(CStr(id))
        Next
        IdSel.SelectedIndex = 0

        'レンジ選択コンボボックスを初期化します
        RangeSel.Items.Add("±10V")
        RangeSel.Items.Add("±5V")
        RangeSel.Items.Add("±2.5V")
        RangeSel.Items.Add("±1V")
        RangeSel.Items.Add("±0.5V")
        RangeSel.Items.Add("±0.25V")
        RangeSel.Items.Add("±0.1V")
        RangeSel.Items.Add("10V")
        RangeSel.Items.Add("5V")
        RangeSel.Items.Add("2.5V")
        RangeSel.Items.Add("1V")
        RangeSel.Items.Add("0.5V")
        RangeSel.Items.Add("0.25V")
        RangeSel.Items.Add("0.1V")
        RangeSel.SelectedIndex = 0

        'チャンネル選択コンボボックスを初期化します
        For ch = 0 To 15
            ChSel.Items.Add(CStr(ch))
        Next ch
        ChSel.SelectedIndex = 0

        'その他初期化
        DataDisp.Text = ""
        RawDisp.Text = ""

        'イネーブルディセーブル制御
        EnableDisableControl(0)
    End Sub

    'イネーブルディセーブル制御
    Private Sub EnableDisableControl(ByVal sel As Boolean)
        DOBtn.Enabled = sel
        DIBtn.Enabled = sel
        SingleSampleBtn.Enabled = sel
        DO0Chk.Enabled = sel
        DO1Chk.Enabled = sel
        RangeSel.Enabled = sel
        ChSel.Enabled = sel
        IdSel.Enabled = Not (sel)
        OpenBtn.Enabled = Not (sel)
        CloseBtn.Enabled = sel
    End Sub

    'デバイスオープン
    Private Sub OpenBtn_Click(sender As System.Object, e As System.EventArgs) Handles OpenBtn.Click
        Dim ret As Short

        ret = Tusbadsms_Device_Open(IdSel.SelectedIndex)
        If ret Then 'エラー発生
            MsgBox(Tusbadsms_GetErrMessage(ret))
        Else '成功
            'イネーブルディセーブル制御
            EnableDisableControl(1)
        End If
    End Sub

    Private Sub CloseBtn_Click(sender As System.Object, e As System.EventArgs) Handles CloseBtn.Click
        Tusbadsms_Device_Close(IdSel.SelectedIndex)
        'イネーブルディセーブル制御
        EnableDisableControl(0)
    End Sub

    Private Sub DOBtn_Click(sender As System.Object, e As System.EventArgs) Handles DOBtn.Click
        Dim ret As Short
        Dim dat As Byte

        'ビットパターン作成
        If DO0Chk.Checked Then
            dat = dat + 1
        End If
        If DO1Chk.Checked Then
            dat = dat + 2
        End If

        '出力
        ret = Tusbadsms_Pio_Write(IdSel.SelectedIndex, dat)

        'エラーチェック
        If ret Then
            MsgBox(Tusbadsms_GetErrMessage(ret))
        End If
    End Sub

    Private Sub DIBtn_Click(sender As System.Object, e As System.EventArgs) Handles DIBtn.Click
        Dim ret As Short
        Dim dat As Byte

        '入力
        ret = Tusbadsms_Pio_Read(IdSel.SelectedIndex, dat)

        'エラーチェック
        If ret Then
            MsgBox(Tusbadsms_GetErrMessage(ret))
        Else
            If dat And 1 Then 'ビット0がHIGHならば
                DI0Lmp.Image = ImageList1.Images(1)
            Else 'LOWならば
                DI0Lmp.Image = ImageList1.Images(0)
            End If

            If dat And 2 Then 'ビット1がHIGHならば
                DI1Lmp.Image = ImageList1.Images(1)
            Else 'LOWならば
                DI1Lmp.Image = ImageList1.Images(0)
            End If
        End If
    End Sub

    Private Sub SingleSampleBtn_Click(sender As System.Object, e As System.EventArgs) Handles SingleSampleBtn.Click
        Dim ret As Short
        Dim dat As Short

        ret = Tusbadsms_Single_Sample(IdSel.SelectedIndex, ChSel.SelectedIndex, _
                                    RangeSel.SelectedIndex, dat)
        If ret Then
            MsgBox(Tusbadsms_GetErrMessage(ret))
        Else
            DataDisp.Text = Format(dat, "0000")
            RawDisp.Text = Format(RawToVolt(dat, RangeSel.SelectedIndex), "0.0000")
        End If
    End Sub

    '生データから電圧値への変換
    Public Function RawToVolt(ByVal dat As Short, ByVal range As Byte) As Single
        Select Case range
            Case 0 '±10Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 20.0# - 10.0#
            Case 1 '±5Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 10.0# - 5.0#
            Case 2 '±2.5Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 5.0# - 2.5
            Case 3 '±1Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 2.0# - 1.0#
            Case 4 '±0.5Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 1.0# - 0.5
            Case 5 '±0.25Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 0.5 - 0.25
            Case 6 '±0.1Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 0.2 - 0.1
            Case 7 '10Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 10.0#
            Case 8 '5Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 5.0#
            Case 9 '2.5Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 2.5
            Case 10 '1Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 1.0#
            Case 11 '0.5Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 0.5
            Case 12 '0.25Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 0.25
            Case 13 '0.1Vレンジ
                RawToVolt = CSng(dat) / 4096.0# * 0.1
            Case Else
                RawToVolt = 0.0#
        End Select
    End Function
End Class
